## Generating function
FixRobModel <- function(center = ParamFamily(), neighbor = ContNeighborhood()){
    new("FixRobModel", center = center, neighbor = neighbor)
}

## Replace methods
setReplaceMethod("neighbor", "FixRobModel", 
    function(object, value){ 
        object@neighbor <- value 
        if(!is(value, "UncondNeighborhood"))
            stop("'value' is no unconditional neighborhood")
        if(any(value@radius < 0 || value@radius > 1))
            stop("neighborhood radius has to be in [0, 1]")
        object
    })
